<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
// local reference to another doc
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>


// categories: std | bcp | info | exp | historic
rfc(category='std' number='2820017' consensus='false' ipr='trust200902' docName='motion-control-software-architecture-01' submissionType='be-cem-mro' xml:lang='en' version='3')
  front
    title(abbrev='Motion-control software architecture') motion-control software architecture
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor' surname='Fargier')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    date(year='2022' month="May" day="13")

    keyword template

    abstract
      t This document describes the motion-control software architecture, as implemented in SAMbuCa project.

  middle

    section
      name Introduction
      t
        | This document describes the motion-control software architecture, as implemented in
        | SAMbuCa (high performance field Sensors
        | Acquisition and Motion Control systems) project.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

    section
      name Motion-Control

      t
        | Motion-Control in SAMbuCa is provided by the #[xref(target="s-motion-lib") motion-lib].

      include motion-control-software-architecture/01.1_general_overview.pug
      include motion-control-software-architecture/01.2_motion_lib.pug
      include motion-control-software-architecture/01.3_grbl.pug

  back

    references
      name References
      references
        name Normative References
        | &rfc2119;

      references
        name Informative References

      references
        name URL References
        reference(anchor='xml2rfc' target='http://xml.resource.org')
          front
            title XML2RFC tools and documentation
            author
              organization RFC Editor
            date(year='2013')

        reference(anchor='GRBL_HAL' target='https://github.com/grblHAL/core/wiki')
          front
            title grblHAL is a no-compromise, high performance, low cost alternative to parallel-port-based motion control for CNC milling
            author(fullname='Terje Io')
            author(fullname='Sungeun K. Jeon')
              organization Gnea Research LLC
            author(fullname='Simen Svale Skogsrud')
            author(fullname='Jens Geisler')
          annotation #[tt License: GPLv3]

        reference(anchor='GCODE' target='https://en.wikipedia.org/wiki/G-code')
          front
            title G-code (also RS-274) is the most widely used computer numerical control (CNC) programming language.
            author
              organization Massachusetts Institute of Technology

        reference(anchor='LIBUCONTEXT' target='https://github.com/kaniini/libucontext')
          front
            title libucontext is a library which provides the ucontext.h C API.
            author(fullname='Ariadne Conill')
              address #[email ariadne@dereferenced.org]
          annotation #[tt Note:] as described in #[eref(target='https://pubs.opengroup.org/onlinepubs/009695399/basedefs/ucontext.h.html') POSIX 2001] but removed in 2008 in favor of POSIX threads.
          annotation #[tt License: ASIS]

        reference(anchor="FESA" target='https://wikis.cern.ch/display/FESA3/FESA3+Home')
          front
            title Front-End Software Architecture (FESA) framework, is a comprehensive environment for equipment-specialists to design, develop, test and deploy real-time control software for front-end computers.
            author
              organization CERN

        reference(anchor="EDGE" target='https://gitlab.cern.ch/be-cem-edl/fec/utilities/edge')
          front
            title EDGE (Encore Driver GEnerator) is a python tool generating ready-to-use Linux device driver sources and relative user-space libraries.
            author
              organization CERN

      references
        name API and technical documentation
        reference(anchor='MOTIONLIB_API' target='https://mro-dev.web.cern.ch/ci/mro/controls/sambuca/sambuca-motion-lib/doc')
          front
            title Motion-Lib API documentation
            author #[organization CERN]

    //- section
    //-   name Change Log
    //-
    //- section
    //-   name Open Issues
